#!/bin/sh

echo "Setting the name of the variables"
NAME="SWTextEdit"
RES="resource"
echo.


echo "Creating object files of all gif images"
cd img
for GIF in `ls *.gif`
do
  OBJ=`echo $GIF |sed 's/\.gif$/\.o/'`
  echo "$GIF"
  gcj --resource=img/$GIF -Os -c $GIF -o $OBJ
done
cd ..
echo.


echo "Creating object files of all language files"
cd lang
for LANG in `ls *.properties`
do
  OBJ=`echo $LANG |sed 's/\.properties$/\.o/'`
  echo "$LANG"
  gcj --resource=lang/$LANG -Os -c $LANG -o $OBJ
done
cd ..
echo.


echo "Compile all java files to object files"
for JAVA in `find . -name "*.java" -print |sed 's/^\.\///'`
do
  OBJ=`echo $JAVA |sed 's/\//_/g' |sed 's/\.java$/\.o/'`
  echo "$JAVA"
  gcj --classpath='.;swt.jar' -fjni -g0 -Os -c $JAVA -o $OBJ
done
echo.


echo "Creating library file of all object files"
ar -rcs lib$NAME.a *.o
echo.


echo "Creating object file for the windows resources of the exe file"
windres --input-format=res --output-format=coff --input=$RES.res --output=$RES.o
echo.


echo "Creating the exe file"
gcj -mwindows --main=net.sf.pisee.swtextedit.Main --classpath=swt.jar \
    -fjni -g0 -Os -s -o $NAME lib$NAME.a $RES.o img/*.o lang/*.o -lswt
echo.


echo "Compress the exe file with UPX"
upx --best $NAME.exe
echo.


echo "Remove the library file and all object files"
rm lib$NAME.a *.o img/*.o lang/*.o
echo.
